<?php

// Check if we're in Joombla
$isInsideJoomla = class_exists('Joomla\CMS\Factory');

if ($isInsideJoomla) {
    echo "<script>\n\tvar isInsideJoomla = true;\n</script>\n";
    echo "<script src='components/com_scriptexplorer/tiqGraphQLHelpers.js'></script>\n";

} else {
    echo "<script>\n\tvar isInsideJoomla = false;\n</script>\n";
    echo "<script src='getToken.js'></script>\n";
    echo "<script src='tiqGraphQLHelpers.js'></script>\n";
    echo "<link href='https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css' rel='stylesheet'>\n";
    echo "<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css'
    integrity='sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm' crossorigin='anonymous'>\n";

}

?>

<div class="pl-4 pt-4" id="app">
    <h1>Script Explorer</h1>
    <div v-for="aHost in hosts">
        <div @click="aHost.showScripts=!aHost.showScripts">
            <i v-bind:class="aHost.showScripts ? 'fa fa-angle-down' : 'fa fa-angle-right'"
                style="font-size: 2em; color: black;"></i>
            <span class="pl-2 h4">{{aHost.displayName}}
                ({{scripts.filter(x=>x.partOf.displayName==aHost.displayName).length}})</span>
            <span>{{aHost.fqnList.join('/')}}</span>
        </div>
        <div class="pl-4 pt-4" v-if="aHost.showScripts">
            <table class="table table-sm d-flex">
                <!-- <tr>
                        <th>DisplayName</th>
                        <th>Mini-IDE</th>
                    </tr> -->
                <tr
                    v-for="aScript in scripts.filter(x=>x.partOf.displayName==aHost.displayName).sort((a, b) => (a.displayName > b.displayName) ? 1 : -1)">
                    <td>{{aScript.displayName}}</td>
                    <td class="text-center">
                        <a v-bind:href="'index.php?option=com_modeleditor&view=script&id=' + aScript.id"
                            target="_blank">
                            <i class="color-inherit fa fa-gear" style="font-size: 1.5em; color: black;"></i>
                        </a>
                    </td>
                </tr>
            </table>
        </div>
    </div>
</div>


<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>

<script>
// a simple vue app
var myApp = new Vue({

    el: '#app',

    data() {
        return {
            hostIds: [],
            hosts: [],
            scripts: []
        }
    },
    mounted(){
        this.getScripts();
    },
    methods: {

        // a function to retrieve libraries from the model
        getScripts: function() {
            let this_vue = this;
            let query = `
                        query myQuery2 {
                            things(condition: { systemType: "script" }) {
                                id
                                displayName
                                relativeName
                                fqnList
                                partOf {
                                    id
                                    displayName
                                    fqnList
                                }
                            }
                        }
                        `;
            makeRequestAsync(query).then(result => {
                // console.log(query);
                this_vue.scripts = result.data.things.filter(x => x.partOf != null);
                this_vue.hostIds = [...new Set(this_vue.scripts.map(item => item.partOf.id))];
                this_vue.hosts = this_vue.hostIds.map(x => {
                    let aScript = this_vue.scripts.find(y => y.partOf.id == x);
                    return {
                        "displayName": aScript.partOf.displayName,
                        "id": aScript.partOf.id,
                        "showScripts": false,
                        "fqnList": aScript.partOf.fqnList,
                        "url": aScript.partOf.fqnList.join('/')
                    };
                }).sort((a, b) => (a.displayName > b.displayName) ? 1 : -1);
            });
        }
    }
});

</script>